<!DOCTYPE html>
    <html>
    <head>
        <meta http-equiv="Content-type" content="text/html;charset=UTF-8">
        <title>Goal Server <!-- omit in toc --></title>
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/katex@0.10.0/dist/katex.min.css" integrity="sha384-9eLZqc9ds8eNjO3TmqPeYcDj8n+Qfa4nuSiGYa6DjLNcv9BtN69ZIulL9+8CqC9Y" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/gh/Microsoft/vscode/extensions/markdown-language-features/media/markdown.css">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/gh/Microsoft/vscode/extensions/markdown-language-features/media/highlight.css">
        <link href="https://cdn.jsdelivr.net/npm/katex-copytex@latest/dist/katex-copytex.min.css" rel="stylesheet" type="text/css">
        <style>
.task-list-item { list-style-type: none; } .task-list-item-checkbox { margin-left: -20px; vertical-align: middle; }
</style>
        <style>
            body {
                font-family: -apple-system, BlinkMacSystemFont, 'Segoe WPC', 'Segoe UI', 'Ubuntu', 'Droid Sans', sans-serif;
                font-size: 14px;
                line-height: 1.6;
            }
        </style>
        
        <script src="https://cdn.jsdelivr.net/npm/katex-copytex@latest/dist/katex-copytex.min.js"></script>
    </head>
    <body>
        <h1 id="goal-server----omit-in-toc">Goal Server <!-- omit in toc --></h1>
<p>The Goal Server is written in arduino/C++ specifically for the esp32. Whenever a goal is scored the esp32 wakes up from deep sleep and tries to send its information for a few seconds to the Pi. When it gets the confirmation that the data has been received or it times out it goes back into deep sleep.</p>
<h2 id="table-of-contents"><a href="#table-of-contents">Table of Contents</a></h2>
<ul>
<li><a href="#table-of-contents">Table of Contents</a></li>
<li><a href="#architecture">Architecture</a>
<ul>
<li><a href="#software-management">Software management</a></li>
<li><a href="#communication-of-iot-devices">Communication of IoT Devices</a></li>
<li><a href="#esp32-power-modes">ESP32 Power Modes</a>
<ul>
<li><a href="#deep-sleep-vs-hibernation">Deep Sleep vs Hibernation</a></li>
</ul>
</li>
<li><a href="#future">Future</a></li>
</ul>
</li>
<li><a href="#saving-goals">Saving Goals</a></li>
<li><a href="#alive-and-updates">Alive and updates</a></li>
<li><a href="#some-infos-about-the-hardware">Some Infos about the Hardware</a></li>
<li><a href="#ubuntu">Ubuntu</a>
<ul>
<li><a href="#vs-code-formatting-and-auto-completion-error">VS Code Formatting and auto-completion error</a></li>
</ul>
</li>
</ul>
<h2 id="architecture"><a href="#architecture">Architecture</a></h2>
<p>Because a pitcure explains more than a thousand words: <br />
<img src="file:////home/joe/git/lightsensors/pictures/architecture.png" width="400" style="margin:20px" /> <br /></p>
<h3 id="software-management">Software management</h3>
<p>Management of the software is done in the cloud and then automatically synchronized between the cloud master and the edge controller. Currently, the edge part is running a full fledged K8S solution, but the plan is to switch something a lot smaller, e.g. K3S which has a 40Mb (compressed) binary. Deployments are all done via Containers and we can reap all the benefits of using K8S, i.e. rolling deployments, health checks, networking. A update for the esp32 is build on the client (or server) inside a container. The container is then deployed on the Pi where it sends the data to the esp32. When the esp32 sends the correct/new version in its beacon the container stops. (Maybe: For updates the esp32 enables a full bluetooth connection.)
<br /></p>
<h3 id="communication-of-iot-devices"><a href="#communication-of-iot-devices">Communication of IoT Devices</a></h3>
<p>The Pi and esp32 communicate via BLE, where the esp32 is the Server and the Pi is the client. The BLE is in deep sleep for most of the time and only woken up by a new goal (see Future for battery consideration.).</p>
<h3 id="esp32-power-modes"><a href="#esp32-power-modes">ESP32 Power Modes</a></h3>
<p>There are serveral power modes for the esp32 <em>Active</em>, <em>Modem Sleep</em>, <em>Light Sleep</em>, <em>Deep Sleep</em> and <em>Hibernation</em>. We chose Deep Sleep as it offers to wake up the device from a sensor as well as in a predefined time. <br />
<strong>Deep Sleep</strong> <br />
<img src="file:////home/joe/git/lightsensors/pictures/esp32DeepSleep.png" width="400px" style="margin-left:20px" /> <br />
Courtesy of <a href="https://lastminuteengineers.com/esp32-sleep-modes-power-consumption/">https://lastminuteengineers.com/esp32-sleep-modes-power-consumption/</a> <br/></p>
<p></p>
<h4 id="deep-sleep-vs-hibernation">Deep Sleep vs Hibernation</h4>
<p>Hibernation offers even more power savings, up to 4 times more (which is a difference of 7.5 microA...), but it is not really documented by espessif (maker of esp32).<br />
So for the moment we are sticking with deep sleep, but are looking into hibernation.</p>
<h3 id="future"><a href="#future">Future</a></h3>
<p>There are two approaches for handling the sensors: <br /></p>
<ul class="contains-task-list">
<li class="task-list-item"><input class="task-list-item-checkbox" checked="" disabled="" type="checkbox"> Let the laser and sensor run all and they wake up the esp32.</li>
<li class="task-list-item"><input class="task-list-item-checkbox" disabled="" type="checkbox"> The esp32 controls the laser/sensor with a mosfet. It has a game mode where it is polling the Pi, with a polling frequency of 10 seconds during rush hour. If there is a game, the esp32 goes into game mode. <br /></li>
</ul>
<!-- https://lastminuteengineers.com/esp32-sleep-modes-power-consumption/ -->
<p>For more information about power states on the esp32</p>
<h2 id="saving-goals">Saving Goals</h2>
<p>The esp32 only tries to send a goal for 5 seconds, when it can reach the Pi it goes back into deep sleep and forgets about the goal. This is to keep it simple and not check states after wake ups. <br />
<em>Not implemented:</em> On the Pi we save the state of a current game until either it reaches the cloud again or the game is over. This is so that we don't have to check times between games in the cloud and onprem.</p>
<h2 id="alive-and-updates"><a href="#polling-alive-and-updates">Alive and updates</a></h2>
<p>The esp32 connects to the Pi once a while to ask for updates and tell it that is still working normally. <em>Not implemented:</em> If no update for a while, the Pi can send of an alarm for the sys admin to check the Pi. <br />
In predefined updates (maybe 30 minutes) the esp32 wakes itself up and polls the raspberry for updates, to synch time and maybe more stuff in the future.
<em>Not implemented:</em> OTA updates are possible with the esp32 but the memory is limitted make it (almost) impossbile to use with the buetooth module.</p>
<h2 id="some-infos-about-the-hardware">Some Infos about the Hardware</h2>
<p><a href="https://circuitdigest.com/microcontroller-projects/getting-started-with-esp32-with-arduino-ide">https://circuitdigest.com/microcontroller-projects/getting-started-with-esp32-with-arduino-ide</a></p>
<h2 id="ubuntu">Ubuntu</h2>
<h3 id="vs-code-formatting-and-auto-completion-error">VS Code Formatting and auto-completion error</h3>
<p>install libtinfo5 for code completion and formatting to work <br />
<code>sudo apt install libtinfo5</code></p>

    </body>
    </html>